<?php
/**
* @copyright infograf768 and various GPL sources
* @license http://www.gnu.org/licenses/gpl-2.0.html GNU/GPL
* Joomla 1.5 native
*/

defined( '_JEXEC' ) or die( 'Restricted access' );
jimport( 'joomla.plugin.plugin');
$mainframe->registerEvent( 'onPrepareContent', 'plgContentJwrapperbot' );

function plgContentJwrapperbot( &$row, &$params, $page=0 ) {
	$db =& JFactory::getDBO();
	// simple performance check to determine whether bot should process further
	if ( JString::strpos( $row->text, 'wrap' ) === false ) {
		return true;
	}	
// Get plugin info
	$plugin =& JPluginHelper::getPlugin('content', 'jwrapperbot');
	$regex = "#{wrap*(.*?)}(.*?){/wrap}#s";
    $pluginParams = new JParameter( $plugin->params );

// check whether plugin has been unpublished
	if ( !$pluginParams->get( 'enabled', 1 ) ) {
	$row->text = preg_replace( $regex, '', $row->text );
    return true;
     }
	// perform the replacement
    $row->text = preg_replace_callback( $regex, 'plgJwrapperbot_replacer', $row->text );
    return true;
}

function plgJwrapperbot_replacer( &$matches ) {
   global $mainframe;
	$plugin =& JPluginHelper::getPlugin('content', 'jwrapperbot');
	$pluginParams = new JParameter( $plugin->params );
	
	$url = $matches[2];

	$wrap_params['name'] = $pluginParams->get( 'name', 'contentframe' );
	$wrap_params['height'] = $pluginParams->get( 'height', '500' );
	$wrap_params['width'] = $pluginParams->get( 'width', '500' );
	$wrap_params['scrolling'] = $pluginParams->get( 'scrolling', '0' );
	$wrap_params['class'] = $pluginParams->get( 'class', 'jwrapper' );
	$wrap_params['height_auto'] =$pluginParams->get( 'height_auto', '0' );
	$wrap_params['component'] =$pluginParams->get( 'component', '0' );
	$wrap_params['target'] = $pluginParams->get( 'target', '0' );
	
	if(isset($matches[1]) && $matches[1]) {
	$wrap_params0 = & JUtility::parseAttributes($matches[1]);
	
	if(isset($wrap_params0['name']) )          $wrap_params['name']       = $wrap_params0['name'];
	if(isset($wrap_params0['height']) )        $wrap_params['height']       = (int)$wrap_params0['height'];
	if(isset($wrap_params0['width']) )       $wrap_params['width']   = (int)$wrap_params0['width'];
	if(isset($wrap_params0['scrolling']))         $wrap_params['scrolling']      =  $wrap_params0['scrolling'];
	if(isset($wrap_params0['class']) )            $wrap_params['class']           = $wrap_params0['class'];
	if(isset($wrap_params0['height_auto']) )           $wrap_params['height_auto']       = $wrap_params0['height_auto'];
	if(isset($wrap_params0['component']) )           $wrap_params['component']       = (int)$wrap_params0['component'];
	if(isset($wrap_params0['target']) )    $wrap_params['target']   = (int)$wrap_params0['target'];
	}
	
    if ($wrap_params['height_auto'] )  {
		$autoheight= 'onload="iFrameHeight()"';
		$myscript =" <script language='javascript' type='text/javascript'>
		function iFrameHeight() {
			var h = 0;
			if ( !document.all ) {
				h = document.getElementById('blockrandom').contentDocument.height;
				document.getElementById('blockrandom').style.height = h + 60 + 'px';
			} else if( document.all ) {
				h = document.frames('blockrandom').document.body.scrollHeight;
				document.all.blockrandom.style.height = h + 20 + 'px';
			}
		}
		</script>";
		} else {
		$autoheight ='';
		$myscript='';		
	}
//If a component is loaded in the IFrame, the url has to be changed
//In this case one may need to load a target tag in it of the type _top or _blank through the jtarget plugin
if (strpos( $url, 'index.php') !== false) { 
	if ($wrap_params['component'] && $wrap_params['target']) {
	$url=''.$url.'&tmpl=component&targetag='.$wrap_params['target'].'';}
	else if ($wrap_params['component']) {
	$url =''.$url.'&tmpl=component';}
} else {
	if ($wrap_params['component'] && $wrap_params['target']) {
	$url=''.$url.'?tmpl=component&targetag='.$wrap_params['target'].'';}
    else if ($wrap_params['component']) {
    $url =''.$url.'?tmpl=component';}
	
//prevents target to be implemented without implementing component
	else if ($wrap_params['target']) {
	$url =$url;}
	}

	$parameters =   'id="blockrandom" '.
	            'name="'.$wrap_params['name'].'" '.
				'src="'.$url.'" '.
				'width="'.$wrap_params['width'].'" '.
				'height="'.$wrap_params['height'].'" '.
				'frameborder="0" '.
				'allowtransparency="true" '.				
				'scrolling="'.$wrap_params['scrolling'].'" '.
				'class="'.$wrap_params['class'].'" ';

    
     $text=" ".$myscript."<iframe ".$autoheight." ".$parameters." >\n".
        "<p>Sorry, your browser cannot display frames!</p>\n".
        "</iframe>\n";   

	return $text;
}

?>